"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.changeEventFromEntry = void 0;
const versions_1 = require("./versions");
function changeEventFromEntry(entry) {
    const [revision, fields] = entry;
    const event = {
        type: 'remove',
        revision: revision.toString(),
    };
    for (let i = 0; i < fields.length; i += 2) {
        const field = fields[i].toString();
        const value = fields[i + 1];
        if (field === 'prev') {
            event.prevRevision = value.toString();
        }
        else if (field === 'key') {
            event.key = value;
        }
        else if (field === 'value') {
            event.value = value;
            event.type = 'set';
        }
        else if (field === 'version') {
            event.version = versions_1.versionFromString(value.toString());
        }
    }
    return event;
}
exports.changeEventFromEntry = changeEventFromEntry;
//# sourceMappingURL=changeEvents.js.map