"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initCommands = void 0;
const get_1 = require("./operations/get");
const set_1 = require("./operations/set");
const compareAndSet_1 = require("./operations/compareAndSet");
const remove_1 = require("./operations/remove");
const compareAndRemove_1 = require("./operations/compareAndRemove");
const getVersionRange_1 = require("./operations/getVersionRange");
const getKeyRange_1 = require("./operations/getKeyRange");
const removeKeyRange_1 = require("./operations/removeKeyRange");
const removeVersionRange_1 = require("./operations/removeVersionRange");
function initCommands(redis) {
    get_1.defineGetCommand(redis);
    set_1.defineSetCommand(redis);
    compareAndSet_1.defineCompareAndSetCommand(redis);
    remove_1.defineRemoveCommand(redis);
    compareAndRemove_1.defineCompareAndRemoveCommand(redis);
    getVersionRange_1.defineGetVersionRangeCommand(redis);
    getKeyRange_1.defineGetKeyRangeCommand(redis);
    removeKeyRange_1.defineRemoveKeyRangeCommand(redis);
    removeVersionRange_1.defineRemoveVersionRangeCommand(redis);
}
exports.initCommands = initCommands;
//# sourceMappingURL=initCommands.js.map