"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKey = exports.REVISION_SUFFIX = exports.CHANGES_STREAM_SUFFIX = exports.VERSIONS_SORTED_SET_SUFFIX = exports.KEYS_SORTED_SET_SUFFIX = exports.VALUES_HASH_SUFFIX = void 0;
/**
 * Hash of collection items key -> value.
 */
exports.VALUES_HASH_SUFFIX = 'values';
/**
 * Sorted Set of keys with all scores set to `0`.
 */
exports.KEYS_SORTED_SET_SUFFIX = 'keys';
/**
 * Sorted set of keys scored by version.
 */
exports.VERSIONS_SORTED_SET_SUFFIX = 'versions';
/**
 * Stream of entries with fields:
 * - prev: stream id of previous entry or 0-0 for the first entry
 * - key: key of changed item
 * - value: updated item value, empty for remove
 * - version: updated item version, empty for remove
 */
exports.CHANGES_STREAM_SUFFIX = 'changes';
/**
 * Stream ID of the last changes stream entry.
 */
exports.REVISION_SUFFIX = 'revision';
function getKey(collection, suffix) {
    return `${collection}:${suffix}`;
}
exports.getKey = getKey;
//# sourceMappingURL=keys.js.map