/// <reference types="node" />
import IORedis = require('ioredis');
import { CompareOperator } from '../compareOperators';
declare module 'ioredis' {
    interface Redis {
        lcCompareAndRemoveBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, compareOperator: string, compareVersion: string, maxlen: number): Promise<[Buffer, null | 1]>;
    }
    interface Cluster {
        lcCompareAndRemoveBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, compareOperator: string, compareVersion: string, maxlen: number): Promise<[Buffer, null | 1]>;
    }
    interface Pipeline {
        lcCompareAndRemoveBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, compareOperator: string, compareVersion: string, maxlen: number, callback?: IORedis.Callback<[Buffer, null | 1]>): IORedis.Pipeline;
    }
}
export declare function defineCompareAndRemoveCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformCompareAndRemoveArguments(collection: string, key: string | Buffer, compareOperator: CompareOperator, compareVersion: number, maxlen?: number): Parameters<IORedis.Redis['lcCompareAndRemoveBuffer']>;
export declare type CompareAndRemoveResult = {
    revision: string;
    success: boolean;
};
export declare function transformCompareAndRemoveReply(reply: [Buffer, null | 1]): CompareAndRemoveResult;
export declare function compareAndRemove(redis: IORedis.Redis | IORedis.Cluster, collection: string, key: string | Buffer, compareOperator: CompareOperator, compareVersion: number, maxlen?: number): Promise<CompareAndRemoveResult>;
