/// <reference types="node" />
import IORedis = require('ioredis');
import { CompareOperator } from '../compareOperators';
declare module 'ioredis' {
    interface Redis {
        lcCompareAndSetBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, compareOperator: string, compareVersion: string, value: Buffer, version: string, maxlen: number): Promise<[Buffer, null | 1]>;
    }
    interface Cluster {
        lcCompareAndSetBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, compareOperator: string, compareVersion: string, value: Buffer, version: string, maxlen: number): Promise<[Buffer, null | 1]>;
    }
    interface Pipeline {
        lcCompareAndSetBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, compareOperator: string, compareVersion: string, value: Buffer, version: string, maxlen: number, callback?: IORedis.Callback<[Buffer, null | 1]>): IORedis.Pipeline;
    }
}
export declare function defineCompareAndSetCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformCompareAndSetArguments(collection: string, key: string | Buffer, compareOperator: CompareOperator, compareVersion: number, value: Buffer, version?: number, maxlen?: number): Parameters<IORedis.Redis['lcCompareAndSetBuffer']>;
export declare type CompareAndSetResult = {
    revision: string;
    success: boolean;
};
export declare function transformCompareAndSetReply(reply: [Buffer, null | 1]): CompareAndSetResult;
export declare function compareAndSet(redis: IORedis.Redis | IORedis.Cluster, collection: string, key: string | Buffer, compareOperator: CompareOperator, compareVersion: number, value: Buffer, version?: number, maxlen?: number): Promise<CompareAndSetResult>;
