/// <reference types="node" />
import IORedis = require('ioredis');
declare module 'ioredis' {
    interface Redis {
        lcGetBuffer(valuesKey: string, versionsKey: string, revisionKey: string, key: string | Buffer): Promise<[Buffer, Buffer?, Buffer?]>;
    }
    interface Cluster {
        lcGetBuffer(valuesKey: string, versionsKey: string, revisionKey: string, key: string | Buffer): Promise<[Buffer, Buffer?, Buffer?]>;
    }
    interface Pipeline {
        lcGetBuffer(valuesKey: string, versionsKey: string, revisionKey: string, key: string | Buffer, callback?: IORedis.Callback<[Buffer, Buffer?, Buffer?]>): IORedis.Pipeline;
    }
}
export declare function defineGetCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformGetArguments(collection: string, key: string | Buffer): Parameters<IORedis.Redis['lcGetBuffer']>;
export declare type GetResult = {
    revision: string;
    value: Buffer | null;
    version: number;
};
export declare function transformGetReply(reply: [Buffer, Buffer?, Buffer?]): GetResult;
export declare function get(redis: IORedis.Redis, collection: string, key: string | Buffer): Promise<GetResult>;
