/// <reference types="node" />
import IORedis = require('ioredis');
import { CollectionItem } from '../collectionItem';
declare module 'ioredis' {
    interface Redis {
        lcGetKeyRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, revisionKey: string, min: string | Buffer, max: string | Buffer): Promise<[Buffer, Array<[Buffer, Buffer, Buffer]>]>;
    }
    interface Cluster {
        lcGetKeyRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, revisionKey: string, min: string | Buffer, max: string | Buffer): Promise<[Buffer, Array<[Buffer, Buffer, Buffer]>]>;
    }
    interface Pipeline {
        lcGetKeyRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, revisionKey: string, min: string | Buffer, max: string | Buffer, callback?: IORedis.Callback<[Buffer, Array<[Buffer, Buffer, Buffer]>]>): IORedis.Pipeline;
    }
}
export declare function defineGetKeyRangeCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformGetKeyRangeArguments(collection: string, min: string | Buffer, max: string | Buffer): Parameters<IORedis.Redis['lcGetKeyRangeBuffer']>;
export declare type GetKeyRangeResult = {
    revision: string;
    items: CollectionItem[];
};
export declare function transformGetKeyRangeReply(reply: [Buffer, Array<[Buffer, Buffer, Buffer]>]): GetKeyRangeResult;
export declare function getKeyRange(redis: IORedis.Redis | IORedis.Cluster, collection: string, min: string | Buffer, max: string | Buffer): Promise<GetKeyRangeResult>;
