/// <reference types="node" />
import IORedis = require('ioredis');
import { CollectionItem } from '../collectionItem';
declare module 'ioredis' {
    interface Redis {
        lcGetVersionRangeBuffer(valuesKey: string, versionsKey: string, revisionKey: string, min: string, max: string): Promise<[Buffer, Array<[Buffer, Buffer, Buffer]>]>;
    }
    interface Cluster {
        lcGetVersionRangeBuffer(valuesKey: string, versionsKey: string, revisionKey: string, min: string, max: string): Promise<[Buffer, Array<[Buffer, Buffer, Buffer]>]>;
    }
    interface Pipeline {
        lcGetVersionRangeBuffer(valuesKey: string, versionsKey: string, revisionKey: string, min: string, max: string, callback?: IORedis.Callback<[Buffer, Array<[Buffer, Buffer, Buffer]>]>): IORedis.Pipeline;
    }
}
export declare function defineGetVersionRangeCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformGetVersionRangeArguments(collection: string, min: number | string, max: number | string): Parameters<IORedis.Redis['lcGetVersionRangeBuffer']>;
export declare type GetVersionRangeResult = {
    revision: string;
    items: CollectionItem[];
};
export declare function transformGetVersionRangeReply(reply: [Buffer, Array<[Buffer, Buffer, Buffer]>]): GetVersionRangeResult;
export declare function getVersionRange(redis: IORedis.Redis | IORedis.Cluster, collection: string, min: number | string, max: number | string): Promise<GetVersionRangeResult>;
