/// <reference types="node" />
import IORedis = require('ioredis');
declare module 'ioredis' {
    interface Redis {
        lcRemoveBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, maxlen: number): Promise<[Buffer]>;
    }
    interface Cluster {
        lcRemoveBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, maxlen: number): Promise<[Buffer]>;
    }
    interface Pipeline {
        lcRemoveBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, maxlen: number, callback?: IORedis.Callback<[Buffer]>): IORedis.Pipeline;
    }
}
export declare function defineRemoveCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformRemoveArguments(collection: string, key: string | Buffer, maxlen?: number): Parameters<IORedis.Redis['lcRemoveBuffer']>;
export declare type RemoveResult = {
    revision: string;
};
export declare function transformRemoveReply(reply: [Buffer]): RemoveResult;
export declare function remove(redis: IORedis.Redis | IORedis.Cluster, collection: string, key: string | Buffer, maxlen?: number): Promise<RemoveResult>;
