"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.remove = exports.transformRemoveReply = exports.transformRemoveArguments = exports.defineRemoveCommand = void 0;
const fs = require("fs");
const path = require("path");
const keys_1 = require("../keys");
const definition = {
    numberOfKeys: 5,
    lua: fs.readFileSync(path.join(__dirname, 'remove.lua'), 'utf-8'),
};
function defineRemoveCommand(redis) {
    redis.defineCommand('lcRemove', definition);
}
exports.defineRemoveCommand = defineRemoveCommand;
function transformRemoveArguments(collection, key, maxlen = 1000) {
    return [
        keys_1.getKey(collection, keys_1.VALUES_HASH_SUFFIX),
        keys_1.getKey(collection, keys_1.KEYS_SORTED_SET_SUFFIX),
        keys_1.getKey(collection, keys_1.VERSIONS_SORTED_SET_SUFFIX),
        keys_1.getKey(collection, keys_1.CHANGES_STREAM_SUFFIX),
        keys_1.getKey(collection, keys_1.REVISION_SUFFIX),
        key,
        maxlen,
    ];
}
exports.transformRemoveArguments = transformRemoveArguments;
function transformRemoveReply(reply) {
    const [revision] = reply;
    return {
        revision: revision.toString(),
    };
}
exports.transformRemoveReply = transformRemoveReply;
function remove(redis, collection, key, maxlen = 1000) {
    return redis
        .lcRemoveBuffer(...transformRemoveArguments(collection, key, maxlen))
        .then(transformRemoveReply);
}
exports.remove = remove;
//# sourceMappingURL=remove.js.map