/// <reference types="node" />
import IORedis = require('ioredis');
declare module 'ioredis' {
    interface Redis {
        lcRemoveKeyRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, min: string | Buffer, max: string | Buffer, maxlen: number): Promise<[Buffer, number]>;
    }
    interface Cluster {
        lcRemoveKeyRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, min: string | Buffer, max: string | Buffer, maxlen: number): Promise<[Buffer, number]>;
    }
    interface Pipeline {
        lcRemoveKeyRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, min: string | Buffer, max: string | Buffer, maxlen: number, callback?: IORedis.Callback<[Buffer, number]>): IORedis.Pipeline;
    }
}
export declare function defineRemoveKeyRangeCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformRemoveKeyRangeArguments(collection: string, min: string | Buffer, max: string | Buffer, maxlen?: number): Parameters<IORedis.Redis['lcRemoveKeyRangeBuffer']>;
export declare type RemoveKeyRangeResult = {
    revision: string;
    removedCount: number;
};
export declare function transformRemoveKeyRangeReply(reply: [Buffer, number]): RemoveKeyRangeResult;
export declare function removeKeyRange(redis: IORedis.Redis | IORedis.Cluster, collection: string, min: string | Buffer, max: string | Buffer, maxlen?: number): Promise<RemoveKeyRangeResult>;
