/// <reference types="node" />
import IORedis = require('ioredis');
declare module 'ioredis' {
    interface Redis {
        lcRemoveVersionRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, min: string, max: string, maxlen: number): Promise<[Buffer, number]>;
    }
    interface Cluster {
        lcRemoveVersionRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, min: string, max: string, maxlen: number): Promise<[Buffer, number]>;
    }
    interface Pipeline {
        lcRemoveVersionRangeBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, min: string, max: string, maxlen: number, callback?: IORedis.Callback<[Buffer, number]>): IORedis.Pipeline;
    }
}
export declare function defineRemoveVersionRangeCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformRemoveVersionRangeArguments(collection: string, min: number | string, max: number | string, maxlen?: number): Parameters<IORedis.Redis['lcRemoveVersionRangeBuffer']>;
export declare type RemoveVersionRangeResult = {
    revision: string;
    removedCount: number;
};
export declare function transformRemoveVersionRangeReply(reply: [Buffer, number]): RemoveVersionRangeResult;
export declare function removeVersionRange(redis: IORedis.Redis | IORedis.Cluster, collection: string, min: number | string, max: number | string, maxlen?: number): Promise<RemoveVersionRangeResult>;
