/// <reference types="node" />
import IORedis = require('ioredis');
declare module 'ioredis' {
    interface Redis {
        lcSetBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, value: Buffer, version: string, maxlen: number): Promise<[Buffer]>;
    }
    interface Cluster {
        lcSetBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, value: Buffer, version: string, maxlen: number): Promise<[Buffer]>;
    }
    interface Pipeline {
        lcSetBuffer(valuesKey: string, keysKey: string, versionsKey: string, changesKey: string, revisionKey: string, key: string | Buffer, value: Buffer, version: string, maxlen: number, callback?: IORedis.Callback<[Buffer]>): IORedis.Pipeline;
    }
}
export declare function defineSetCommand(redis: IORedis.Redis | IORedis.Cluster): void;
export declare function transformSetArguments(collection: string, key: string | Buffer, value: Buffer, version?: number, maxlen?: number): Parameters<IORedis.Redis['lcSetBuffer']>;
export declare type SetResult = {
    revision: string;
};
export declare function transformSetReply(reply: [Buffer]): SetResult;
export declare function set(redis: IORedis.Redis | IORedis.Cluster, collection: string, key: string | Buffer, value: Buffer, version?: number, maxlen?: number): Promise<SetResult>;
